#include <iostream>

using namespace std;

int main()
{
    int N, O, A, B, AB;

    cin >> N;
    cin >> O >> A >> B >> AB;

    string pacijent_KG[N];
    int pacijent_Jedinica[N];

    int pacijent_Op[N];
    int pacijent_Ap[N];
    int pacijent_Bp[N];
    int pacijent_ABp[N];


    for(int i = 0; i < N; i++){
        string k_g;
        int jed;
        cin >> k_g >> jed;
        pacijent_KG[i] = k_g;
        pacijent_Jedinica[i] = jed;

        pacijent_Op[i] = 0;
        pacijent_Ap[i] = 0;
        pacijent_Bp[i] = 0;
        pacijent_ABp[i] = 0;
    }

    for(int i = 0; i < N; i++){

        if(pacijent_KG[i] == "O"){

            int jed = pacijent_Jedinica[i];

            while(O > 0 && jed > 0){
                O--;
                jed--;
                pacijent_Op[i]++;
            }

            if(jed > 0){
                cout << "nemoguce";
                return 0;
            }

        }
        else if(pacijent_KG[i] == "A"){

            int jed = pacijent_Jedinica[i];

            while(A > 0 && jed > 0){
                A--;
                jed--;
                pacijent_Ap[i]++;
            }
            while(O > 0 && jed > 0){
                O--;
                jed--;
                pacijent_Op[i]++;
            }

            if(jed > 0){
                cout << "nemoguce";
                return 0;
            }
        }
        else if(pacijent_KG[i] == "B"){

            int jed = pacijent_Jedinica[i];

            while(B > 0 && jed > 0){
                B--;
                jed--;
                pacijent_Bp[i]++;
            }
            while(O > 0 && jed > 0){
                O--;
                jed--;
                pacijent_Op[i]++;
            }

            if(jed > 0){
                cout << "nemoguce";
                return 0;
            }
        }
        else if(pacijent_KG[i] == "AB"){

            int jed = pacijent_Jedinica[i];

            while(AB > 0 && jed > 0){
                AB--;
                jed--;
                pacijent_ABp[i]++;
            }
            while(A > 0 && jed > 0){
                A--;
                jed--;
                pacijent_Ap[i]++;
            }
            while(B > 0 && jed > 0){
                B--;
                jed--;
                pacijent_Bp[i]++;
            }
            while(O > 0 && jed > 0){
                O--;
                jed--;
                pacijent_Op[i]++;
            }

            if(jed > 0){
                cout << "nemoguce";
                return 0;
            }

        }

    }

    cout << "moguce" << endl;
    for(int i = 0; i < N; i++){
        cout << pacijent_Op[i] << " "<< pacijent_Ap[i] << " " << pacijent_Bp[i] << " " << pacijent_ABp[i] << " " << endl;
    }

    return 0;
}